



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Caffe中deploy.prototxt 和 train_val.prototxt 区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Caffe中deploy.prototxt 和 train_val.prototxt 区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 05:40:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<blockquote><p>之前用deploy.prototxt 还原train_val.prototxt过程中，遇到了坑，所以打算总结一下</p></blockquote>
<blockquote><p>本人以熟悉的LeNet网络结构为例子</p></blockquote>
<blockquote><p>不同点主要在一前一后，相同点都在中间</p></blockquote>
<h3>train_val.prototxt 中的开头</h3>
<blockquote><p>看这个名字也知道，里面定义的是训练和验证时候的网络，所以在开始的时候要定义训练集和验证集的来源</p></blockquote>
<div>
<pre class="prettyprint linenums">name: "LeNet"<br />
layer {<br />
  name: "mnist"<br />
  type: "Data"<br />
  top: "data"<br />
  top: "label"<br />
  include {<br />
    phase: TRAIN<br />
  }<br />
  transform_param {<br />
    scale: 0.00390625<br />
  }<br />
  data_param {<br />
    # 这里定义了之前将数据集转成lmdb数据格式的文件位置<br />
    source: "examples/mnist/mnist_train_lmdb"<br />
    # 这个定义了一次行送入网络的图像个数<br />
    batch_size: 64<br />
    backend: LMDB<br />
  }<br />
}<br />
layer {<br />
  name: "mnist"<br />
  type: "Data"<br />
  top: "data"<br />
  top: "label"<br />
  include {<br />
    phase: TEST<br />
  }<br />
  transform_param {<br />
    scale: 0.00390625<br />
  }<br />
  data_param {<br />
    # 这里定义了验证集的数据来源<br />
    source: "examples/mnist/mnist_test_lmdb"<br />
    batch_size: 100<br />
    backend: LMDB<br />
  }<br />
}
</pre>
</div>
<p>　　</p>
<h3>deploy.prototxt 中的开头</h3>
<blockquote><p>看这个名字也知道，这个配置文件适用于部署，也就是用于实际场景时候的配置文件，所以开始的时候不必在定义数据集的来源，但是需要定义输入数据的大小格式。</p></blockquote>
<div>
<pre class="prettyprint linenums">name: "LeNet"<br />
layer {<br />
  name: "data"<br />
  type: "Input"<br />
  top: "data"<br />
  # 输入数据的batch size, channel, width, height<br />
  input_param { shape: { dim: 64 dim: 1 dim: 28 dim: 28 } }<br />
}
</pre>
</div>
<p>　　</p>
<h3>train_val.prototxt 中的结尾</h3>
<blockquote><p>如果是一般的卷积网络的话，最后面都是用一个全连接，将feature map 转成固定长度的向量，然后输出种类的个数。所以在最后的时候，需要说明输出种类的个数。</p></blockquote>
<div>
<pre class="prettyprint linenums">layer {<br />
  name: "ip2"<br />
  type: "InnerProduct"<br />
  bottom: "ip1"<br />
  top: "ip2"<br />
  param {<br />
    lr_mult: 1<br />
  }<br />
  param {<br />
    lr_mult: 2<br />
  }<br />
  inner_product_param {<br />
    # 在这里定义了输出种类的个数<br />
    num_output: 10<br />
    weight_filler {<br />
      type: "xavier"<br />
    }<br />
    bias_filler {<br />
      type: "constant"<br />
    }<br />
  }<br />
}
</pre>
</div>
<p>　　</p>
<blockquote><p>因为这里面包含了验证的部分，验证的时候，需要输出结果的准确率，所以需要定义准确率的输出。</p></blockquote>
<div>
<pre class="prettyprint linenums">layer {<br />
  name: "accuracy"<br />
  type: "Accuracy"<br />
  bottom: "ip2"<br />
  bottom: "label"<br />
  top: "accuracy"<br />
  include {<br />
    phase: TEST<br />
  }<br />
}
</pre>
</div>
<p>　　</p>
<blockquote><p>最后还有一个不同就是，因为是训练模型，所以包括forward和backward，所以最后需要定义一个损失函数。这里用的是SoftmaxWithLoss，而在deploy.prototxt，因为只有forward，所以定义的是Softmax，也就是分类器。</p></blockquote>
<div>
<pre class="prettyprint linenums">layer {<br />
  name: "loss"<br />
  # 定义的是损失函数<br />
  type: "SoftmaxWithLoss"<br />
  bottom: "ip2"<br />
  bottom: "label"<br />
  top: "loss"<br />
}
</pre>
</div>
<p>　　</p>
<h3>deploy.prototxt 中的最后</h3>
<blockquote><p>这里定义了Softmax分类器，输出最后各类的概率值。</p></blockquote>
<div>
<pre class="prettyprint linenums">layer {<br />
  name: "prob"<br />
  # 定义的是分类器<br />
  type: "Softmax"<br />
  bottom: "ip2"<br />
  top: "prob"<br />
}
</pre>
</div>
<p>　　</p>
<h3>train_val.prototxt 和 deploy.prototxt中间部分</h3>
<blockquote><p>两个的中间部分都是一样的，定义了一些卷积、激活、池化、Dropout、LRN(local response normalization)、全连接等操作。</p></blockquote>
<div>
<pre class="prettyprint linenums">layer {<br />
  name: "conv1"<br />
  type: "Convolution"<br />
  bottom: "data"<br />
  top: "conv1"<br />
  param {<br />
    lr_mult: 1<br />
  }<br />
  param {<br />
    lr_mult: 2<br />
  }<br />
  convolution_param {<br />
    num_output: 20<br />
    kernel_size: 5<br />
    stride: 1<br />
    weight_filler {<br />
      type: "xavier"<br />
    }<br />
    bias_filler {<br />
      type: "constant"<br />
    }<br />
  }<br />
}<br />
layer {<br />
  name: "pool1"<br />
  type: "Pooling"<br />
  bottom: "conv1"<br />
  top: "pool1"<br />
  pooling_param {<br />
    pool: MAX<br />
    kernel_size: 2<br />
    stride: 2<br />
  }<br />
}<br />
layer {<br />
  name: "conv2"<br />
  type: "Convolution"<br />
  bottom: "pool1"<br />
  top: "conv2"<br />
  param {<br />
    lr_mult: 1<br />
  }<br />
  param {<br />
    lr_mult: 2<br />
  }<br />
  convolution_param {<br />
    num_output: 50<br />
    kernel_size: 5<br />
    stride: 1<br />
    weight_filler {<br />
      type: "xavier"<br />
    }<br />
    bias_filler {<br />
      type: "constant"<br />
    }<br />
  }<br />
}<br />
layer {<br />
  name: "pool2"<br />
  type: "Pooling"<br />
  bottom: "conv2"<br />
  top: "pool2"<br />
  pooling_param {<br />
    pool: MAX<br />
    kernel_size: 2<br />
    stride: 2<br />
  }<br />
}<br />
layer {<br />
  name: "ip1"<br />
  type: "InnerProduct"<br />
  bottom: "pool2"<br />
  top: "ip1"<br />
  param {<br />
    lr_mult: 1<br />
  }<br />
  param {<br />
    lr_mult: 2<br />
  }<br />
  inner_product_param {<br />
    num_output: 500<br />
    weight_filler {<br />
      type: "xavier"<br />
    }<br />
    bias_filler {<br />
      type: "constant"<br />
    }<br />
  }<br />
}<br />
layer {<br />
  name: "relu1"<br />
  type: "ReLU"<br />
  bottom: "ip1"<br />
  top: "ip1"<br />
}<br />
layer {<br />
  name: "ip2"<br />
  type: "InnerProduct"<br />
  bottom: "ip1"<br />
  top: "ip2"<br />
  param {<br />
    lr_mult: 1<br />
  }<br />
  param {<br />
    lr_mult: 2<br />
  }<br />
  inner_product_param {<br />
    num_output: 10<br />
    weight_filler {<br />
      type: "xavier"<br />
    }<br />
    bias_filler {<br />
      type: "constant"<br />
    }<br />
  }<br />
}
</pre>
</div>
<p>　　</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kvjp59.html">JSP弹出窗口和模式对话框</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q72mkj9.html">123&period; Best Time to Buy and Sell Stock （三） leetcode解题笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wk0vq.html">cocos2dx 3&period;0 之 lua 创建类 &lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g7gdl9.html">scala学习心得3</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903nj39.html">expdp报错ora 39126</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew5k09.html">JavaScript中的继承模式总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpd7rxq.html">OpenLayers&period;Map的一些特殊事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp27g59.html">运用经典方法进行横截面数据分类 笔记 （基于R）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydv6e9.html">25&rpar;django-form使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjov369.html">语句调优基础知识-set statistics io on</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7d518.html">Spring标签之Bean  &commat;Scope</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwv3mz8.html">Java静态成员与实例成员</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyp7r39.html">CSS中的偏僻知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jvrkeq.html">luogu1387 最大正方形</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjlepjq.html">Struts 2 - Environment Setup</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlpkpl9.html">Oracle update 日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwodvd39.html">《利用Python进行数据分析》笔记---第4章NumPy基础：数组和矢量计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdjn1yq.html">SGU - 495 概率DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdn7e1q.html">CentOS6&period;6下DRBD&plus;HeartBeat&plus;NFS配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlgpezq.html">web页面实时刷新之browser sync</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2kwo03q.html">Spring-Session实现Session共享Redis集群方式配置教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pxe5w8.html">HttpServlet Service方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/963poo49.html">android studio 使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4jkoeq.html">Redis如何处理客户端连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pzy5nq.html">七层负载&lpar;Application Gateway&rpar;&plus;四层负载&lpar;LB&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7eze7e9.html">linux-socket connect阻塞和非阻塞模式 示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emym0j9.html">linux网络编程：splice函数和tee&lpar; &rpar;函数高效的零拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1joj09.html">PHP 7 来了，PHP 6 去哪儿了？</a>
			</li>
						<li><a href="https://www.batexi.com/a/963pmgv9.html">ASP&period;NET Web API实践系列11&comma;如何设计出优秀的API</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pz45jq.html">Unity3D实践系列05&comma;为GameObject添加额外属性</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
